// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/components/physics/2d/CharacterController2D.hpp"
#include "scene/components/HurtHazard.hpp" 
#include "scene/components/entity/EntityHealth.hpp"
#include "scene/components/entity/EntityMove.hpp"

namespace Dawn {
  class PlayerController : public SceneItemComponent {
    protected:
      CharacterController2D *characterController;
      EntityHealth *entityHealth;
      EntityMove *entityMove;

    public:
      // @optional
      float_t hitKnockback = 20.0f;

      PlayerController(SceneItem *item);
      std::vector<SceneItemComponent*> getDependencies() override;
      void onStart() override;
  };
}